unit GeocitiesUpload_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, OleCtrls, SHDocVw, StdCtrls, ExtCtrls, ShellApi;

type
  TWbState = (wsLogout, wsLogin, wsGoUpload, wsSelectFile, wsUploadDone);
  TForm1 = class(TForm)
    wb: TWebBrowser;
    upload_btn: TSpeedButton;
    logout_btn: TSpeedButton;
    login_btn: TSpeedButton;
    msg: TLabel;
    UploadingTimer: TTimer;
    udir: TComboBox;
    Label1: TLabel;
    acc: TLabeledEdit;
    psw: TLabeledEdit;
    mark1: TLabel;
    mark2: TLabel;
    procedure wbDocumentComplete(Sender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    procedure OpenPage(Sender: TObject);
    procedure UploadingTimerTimer(Sender: TObject);
    procedure accChange(Sender: TObject);
    procedure changeMarkColor(Sender: TObject);
    procedure RecoverMarkColor(Sender: TObject);
    procedure markClick(Sender: TObject);
  private
    FState:TWbState;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.wbDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var doc:OleVariant;
begin
  doc:=wb.OleObject.Document;
  case FState of
    wsLogout:
      begin
        upload_btn.Enabled:=false;
        logout_btn.Enabled:=false;
        login_btn.Enabled:=true;
      end;
    wsLogin:
      begin
        try
          doc.Forms.Item(0).Item('login',0).value:=acc.Text;
          doc.Forms.Item(0).Item('passwd',0).value:=psw.Text;
          Doc.Forms.Item(0).submit;
          upload_btn.Enabled:=true;
          logout_btn.Enabled:=true;
          login_btn.Enabled:=false;
          msg.Caption:=''; Application.ProcessMessages;
        except
        end;
      end;
    wsGoUpload:
      begin
        try
          doc.Forms.Item(0).userfile.Item(0).click;
          upload_btn.Enabled:=false;
          UploadingTimer.Enabled:=true;
          FState:=wsSelectFile;
        except
        end;
      end;
    wsUploadDone:
      begin
        upload_btn.Enabled:=true;
        msg.Caption:='ɮפWǦ\I'; Application.ProcessMessages;
      end;
  end;
end;

procedure TForm1.OpenPage(Sender: TObject);
var s:string;
begin
  msg.Caption:=''; Application.ProcessMessages;
  if Sender=upload_btn then
    begin
      upload_btn.Enabled:=false;
      logout_btn.Enabled:=false;
      FState:=wsGoUpload;
      msg.Caption:='ǳƤWɮ...'; Application.ProcessMessages;
      if udir.Text='[root directory]' then s:='./' else s:=udir.Text;
      wb.Navigate('http://geocities.yahoo.com/filemanager?directory='+s+'&op-uploadtodir');
      upload_btn.Enabled:=true;
      logout_btn.Enabled:=true;
    end
  else if Sender=logout_btn then
    begin
      FState:=wsLogout;
      wb.Navigate('http://login.yahoo.com/config/login?logout=1&.src=geo&.intl=us&.done=http://geocities.yahoo.com/');
      acc.Enabled:=true;
      psw.Enabled:=true;
    end
  else if Sender=login_btn then
    begin
      FState:=wsLogin;
      wb.Navigate('http://geocities.yahoo.com');
      acc.Enabled:=false;
      psw.Enabled:=false;
    end;
end;

procedure TForm1.UploadingTimerTimer(Sender: TObject);
var doc:Variant;
begin
  doc:=wb.OleObject.Document;
  try
    if doc.Forms.Item(0).userfile.Item(0).value<>'' then
      begin
        doc.Forms.Item(0).submit;
        UploadingTimer.Enabled:=false;
        FState:=wsUploadDone;
      end;
  except
    UploadingTimer.Enabled:=false;
    upload_btn.Enabled:=true;
  end;
end;

procedure TForm1.accChange(Sender: TObject);
begin
  login_btn.Enabled:=(acc.Text<>'') and (psw.Text<>'');
end;

procedure TForm1.changeMarkColor(Sender: TObject);
begin
  mark1.Font.Color:=$004080FF;
  mark2.Font.Color:=mark1.Font.Color;
end;

procedure TForm1.RecoverMarkColor(Sender: TObject);
begin
  mark1.Font.Color:=$00FF8000;
  mark2.Font.Color:=mark1.Font.Color;
end;

procedure TForm1.markClick(Sender: TObject);
begin
  ShellExecute(HInstance,'open','http://come.to/snoofield','','',SW_SHOWNORMAL);
end;

end.
